Subject: What day is 2010-01-02

From: Cullen Jennings <[email-masked]>
Date: Sat, 13 Mar 2010 07:51:43 -0700

I just got abused by someone reading the IESG web pages and pointing out dates like 2010-01-02 , are confusing. Is there a better way to do dates that we should be using on the ietf.org web pages?

---

From: Marshall Eubanks <[email-masked]>
Date: Sat, 13 Mar 2010 10:06:46 -0500

On Mar 13, 2010, at 9:51 AM, Cullen Jennings wrote:

>
> I just got abused by someone reading the IESG web pages and pointing  
> out dates like 2010-01-02 , are confusing. Is there a better way to  
> do dates that we should be using on the ietf.org web pages?
>
>

I would disagree. This follows an ISO standard, ISO 8601, and also  
happens to sort properly (in time order).

 From http://www.iso.org/iso/date_and_time_format

ISO 8601 advises numeric representation of dates and times on an  
internationally agreed basis. It represents elements from the largest  
to the smallest element: year-month-day:
	• Calendar date is the most common date representation. It is:
YYYY-MM-DD

where YYYY is the year in the Gregorian calendar, MM is the month of  
the year between 01 (January) and 12 (December), and DD is the day of  
the month between 01 and 31.

Example: 2003-04-01 represents the first day of April in 2003.

So, 2010-01-02 is January 2, 2010.

Regards

Marshall

>
>
>
>
> _______________________________________________
> Ietf mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ietf
>

---

From: Julian Reschke <[email-masked]>
Date: Sat, 13 Mar 2010 16:07:12 +0100

> I just got abused by someone reading the IESG web pages and pointing out dates like 2010-01-02 , are confusing. Is there a better way to do dates that we should be using on the ietf.org web pages?

A better way than the ISO format? I don't think so.

Best regards, Julian

---

From: Scott Brim <[email-masked]>
Date: Sat, 13 Mar 2010 10:09:31 -0500

> I just got abused by someone reading the IESG web pages and pointing out dates like 2010-01-02 , are confusing. Is there a better way to do dates that we should be using on the ietf.org web pages?

2010-JAN-02

---

From: bill manning <[email-masked]>
Date: Sat, 13 Mar 2010 07:13:16 -0800

ISO not withstanding, its still confusing if only because other cultures use
yyddmm.  If the IETF website used something like  ISO-2010-01-02 maybe.

This format is less confusing:  02jan2010

--bill

On 13March2010Saturday, at 7:06, Marshall Eubanks wrote:

> I would disagree. This follows an ISO standard, ISO 8601, and also happens to sort properly (in time order).
> 
> ISO 8601 advises numeric representation of dates and times on an internationally agreed basis. It represents elements from the largest to the smallest element: year-month-day:
> where YYYY is the year in the Gregorian calendar, MM is the month of the year between 01 (January) and 12 (December), and DD is the day of the month between 01 and 31.
>

---

From: Robert Kisteleki <[email-masked]>
Date: Sat, 13 Mar 2010 16:16:15 +0100

On 2010.03.13. 15:51, Cullen Jennings wrote:
>
> I just got abused by someone reading the IESG web pages and pointing out
> dates like 2010-01-02 , are confusing. Is there a better way to do dates
> that we should be using on the ietf.org web pages?

IMO ISO8601 (http://en.wikipedia.org/wiki/ISO_8601) is the best thing since 
sliced bread, and I wish it was widely used in international contexts. I 
mean, I was always amazed when people write 03-04-05 and expect others to 
know what they mean...

BTW, the answer is: Saturday.

Robert

---

From: John C Klensin <[email-masked]>
Date: Sat, 13 Mar 2010 10:17:20 -0500

--On Saturday, March 13, 2010 07:51 -0700 Cullen Jennings
<[email-masked]> wrote:

> I just got abused by someone reading the IESG web pages and
> pointing out dates like 2010-01-02 , are confusing. Is there a
> better way to do dates that we should be using on the ietf.org
> web pages?

First of all, while there have been many efforts to make that
ambiguous, there really is an international standard that
specifies dates in strict little-endian order (e.g., YYYYMMDD)
with optional delimiters (hyphen is now specified, but period
and maybe some other things were, if I recall, permitted in
earlier versions of the standard).  Because of national
conventions, variations, and plain stupidity, all [other]
formats suffer from at least one of three problems:

	(1) Dependency on particular languages, e.g., 1 Jan 2002.
	
	(2) Visual confusability of particular characters in
	common fonts, e.g.,    1 II 2010 could easily be
	mistaken, with the wrong choice of fonts, for 1 11 2020.
	(Curiously, while the appearance of Roman numerals most
	often indicates a month, I've occasionally seen the
	equivalent of XXI 1 2010 and its permutations in the
	wild.)
	
	(3) The permutation problem, which gets particularly
	severe if two-digit years are used, and which is the
	source of the ambiguity you point out.

IMO, if we have a problem (and, if members of the community are
confused, we probably do), the best solution is a short note on
relevant pages (perhaps even in the footer of every page) that
says, e.g., "In accordance with International Standards, all
dates on IETF web pages are either spelled out in full or in ISO
8601 format, i.e., YYYY-MM-DD".  It is not trying to swap out
one ambiguous format for another one that might be slightly less
(or slightly more) ambiguous.

     john

---

From: Donald Eastlake <[email-masked]>
Date: Sat, 13 Mar 2010 10:19:16 -0500

I think the ISO standard is fine. Multi-letter month abbreviations are
probably OK but are a little different in different languages. Lets
stick with 2010-01-02.

Thanks,
Donald

---

From: Cullen Jennings <[email-masked]>
Date: Sat, 13 Mar 2010 08:25:11 -0700

Wow - I never imagined such a rapid response to this question. Thanks. 

I've replied with roughly "Yep, they might be a bit confusing but everything else is worse so that's what we use".

> So, 2010-01-02 is January 2, 2010.

Cullen Jennings
For corporate legal information go to:
http://www.cisco.com/web/about/doing_business/legal/cri/index.html

---

From: Julian Reschke <[email-masked]>
Date: Sat, 13 Mar 2010 16:47:15 +0100

> This format is less confusing:  02jan2010

As far as I recall YYYY-MM-DD was specifically chosen because it's 
unambiguous; no widely used date format uses hyphens and has the 
ordering different.

Just get used to it. And while at it, switch to 24h :-)

Best regards, Julian

---

From: Arnt Gulbrandsen <[email-masked]>
Date: Sat, 13 Mar 2010 17:13:41 +0100

> do dates that we should be using on the ietf.org web pages?

Those are RFC 3339 dates. Tell him to write a draft-rfc3339bis if he's 
unhappy with RFC 3339.

If he thinks that's unreasonable, explain that you're being restrained, 
and that his proper punishment would be to specify imperial 
replacements for kilobyte, megabit and their ilk.

Arnt

---

From: "Doug Ewell" <[email-masked]>
Date: Sat, 13 Mar 2010 10:08:08 -0700

"bill manning" <bmanning at ISI dot EDU> wrote:

> ISO not withstanding, its still confusing if only because other 
> cultures use yyddmm.

Which cultures are those?

--
Doug Ewell  |  Thornton, Colorado, USA  |  http://www.ewellic.org
RFC 5645, 4645, UTN #14  |  ietf-languages @ http://is.gd/2kf0s

---

From: Tony Finch <[email-masked]>
Date: Sat, 13 Mar 2010 17:29:10 +0000

On Sat, 13 Mar 2010, John C Klensin wrote:
>
> there really is an international standard that specifies dates in strict
> little-endian order (e.g., YYYYMMDD)

That's big endian :-)

Tony.
-- 
f.anthony.n.finch  <[email-masked]>  http://dotat.at/
GERMAN BIGHT HUMBER: SOUTHWEST 5 TO 7. MODERATE OR ROUGH. SQUALLY SHOWERS.
MODERATE OR GOOD.

---

From: Cullen Jennings <[email-masked]>
Date: Sat, 13 Mar 2010 11:06:52 -0700

> > little-endian order (e.g., YYYYMMDD)

And it's stored in octets, not bytes (UTF-8 with a lang tag of course)  :-)

BTW Tony - that is an awesome email address speaking of confusing representations.

---

From: Stephane Bortzmeyer <[email-masked]>
Date: Sat, 13 Mar 2010 19:23:51 +0100

On Sat, Mar 13, 2010 at 05:13:41PM +0100,
 Arnt Gulbrandsen <[email-masked]> wrote 
 a message of 17 lines which said:

> Those are RFC 3339 dates.

It took thirteen messages for someone to notice that there is an IETF
standard for dates and that the IETF uses it on its own Web
pages... People should spend more time reading published RFCs :-}

---

From: Stephane Bortzmeyer <[email-masked]>
Date: Sat, 13 Mar 2010 19:30:45 +0100

On Sat, Mar 13, 2010 at 10:06:46AM -0500,
 Marshall Eubanks <[email-masked]> wrote 
 a message of 61 lines which said:

> This follows an ISO standard, ISO 8601,

Sections 5.5 of RFC 3339 explain very well why you should not use ISO
8601 but its subset of RFC 3339.

> and also happens to sort properly (in time order).

ISO 8601 does not really have this property, see section 5.1 of RFC
3339.

---

From: Julian Reschke <[email-masked]>
Date: Sat, 13 Mar 2010 20:15:05 +0100

On 13.03.2010 19:30, Stephane Bortzmeyer wrote:
>   Marshall Eubanks<[email-masked]>  wrote

On the other hand, RFC 3339 refers to an outdated version of ISO 8601, 
and probably should be updated.

> ISO 8601 does not really have this property, see section 5.1 of RFC

Nor does RFC 3339's format (as it allows different notations for the 
timezone offset).

Best regards, Julian

---

From: "Francois D. Menard" <[email-masked]>
Date: Sat, 13 Mar 2010 14:18:03 -0500

For me, the best reason to keep dates in the format of:

YYYYMMDD

is that if you name your files in this way, when you do a directory list, files get sorted in alphabetical order

So if only for this reason, this is why its the ONLY convention I will ever use, even if I decide to learn a third language.

For those who care, being in French Canada, its very important that the date be labelled in the following format

DDMMYYYY

For the last 10 years, I have abandoned this way of dealing with dates, and I am through about 70 people at the office now, teaching them why it make sense to name files in the format of 

YYYYDDMM

Regards,

-=Francois=-

---

From: Tony Finch <[email-masked]>
Date: Sat, 13 Mar 2010 20:12:20 +0000

> > 8601 but its subset of RFC 3339.

[because RFC 3339 is simpler]

> On the other hand, RFC 3339 refers to an outdated version of ISO 8601, and
> probably should be updated.

Happily ISO 8601-2004 is simpler than ISO 8601-2000. One of the most
significant deletions is the option for "truncated representations" i.e.
where leading digits are omitted. Other than that most of the changes are
improvements to the wording.

Tony.

---

From: Scott Brim <[email-masked]>
Date: Sat, 13 Mar 2010 16:58:02 -0500

These technical answers are all great "for use in Internet protocols"
[3339] but the scope of the question is web pages destined for humans to
read and understand ... and some humans don't understand them.  You
could justify what's there now and ignore their problem, or (if your
goal is communication) you could figure out how to write dates in ways
that ordinary humans find unambiguous.  I usually write something like
"2010 Jan 02".  It's not sortable but it's understood even by non-IETFers.

---

From: Marshall Eubanks <[email-masked]>
Date: Sat, 13 Mar 2010 17:10:05 -0500

On Mar 13, 2010, at 10:47 AM, Julian Reschke wrote:

>> cultures use

Exactly.

Marshall

---

From: Mark Andrews <[email-masked]>
Date: Sun, 14 Mar 2010 09:18:35 +1100

In message <[email-masked]>, Marshall Euba
> > unambiguous; no widely used date format uses hyphens and has the  

It's confusing but not ambigious.
 
-- 
Mark Andrews, ISC
1 Seymour St., Dundas Valley, NSW 2117, Australia
PHONE: +61 2 9871 4742                 INTERNET: [email-masked]

---

From: Ofer Inbar <[email-masked]>
Date: Sat, 13 Mar 2010 17:24:17 -0500

> "2010 Jan 02".  It's not sortable but it's understood even by non-IETFers.

I've been using YYYY-MM-DD dates everywhere I can for many years, and
the email that opened this thread was the first time I had ever heard
of anyone ever finding such a date ambiguous.  Given the various
advantages of such dates, I think we need to be convinced that there's
an actual problem before considering changing them.

Humans and scripts often access the same data, BTW.  Easy-to-parse
dates are advantageous.  Matching international standards is also
of some value.
  -- Cos

---

From: Marshall Eubanks <[email-masked]>
Date: Sat, 13 Mar 2010 17:34:29 -0500

> ISO 8601 does not really have this property, see section 5.1 of RFC

Why not ? The complete 5.1 from RFC 3339
5.1.
Ordering If date and time components are ordered from least precise to  
most precise, then a useful property is achieved. Assuming that the  
time zones of the dates and times are the same (e.g., all in UTC),  
expressed using the same string (e.g., all "Z" or all "+00:00"), and  
all times have the same number of fractional second digits, then the  
date and time strings may be sorted as strings (e.g., using the  
strcmp() function in C) and a time-ordered sequence will result. The  
presence of optional punctuation would violate this characteristic.
-----
Also, note that we are talking about _dates_. While daylight savings  
time may complicate time sortability, it won't affect date sortability.

Regards
Marshall

---

From: Mark Andrews <[email-masked]>
Date: Sun, 14 Mar 2010 09:50:02 +1100

> "2010 Jan 02".  It's not sortable but it's understood even by non-IETFers.

And even that can be confusing if English is not a language you
understand.

---

From: Joel Jaeggli <[email-masked]>
Date: Sat, 13 Mar 2010 16:10:23 -0800

> an actual problem before considering changing them.

the nice thing about standards is there are so many to choose from...

joelja@chickenhawk:~$ date --rfc-2822
Sat, 13 Mar 2010 16:07:43 -0800

joelja@chickenhawk:~$ date --rfc-3339=date
2010-03-13

joelja@chickenhawk:~$ date +%s
1268525289

I know which of those I'd rather use in a script.

---

From: Brian E Carpenter <[email-masked]>
Date: Sun, 14 Mar 2010 14:16:06 +1300

> "2010 Jan 02".  It's not sortable but it's understood even by non-IETFers.

In Russia, China, Arabic-writing countries, etc.?

I've preferred the 2010-03-14 format (with or without the hypens)
since 1977, when I found myself installing the 770517C release of
an operating system. OK, that abbreviation does incorporate the
Y2K bug, but when working in an industry generally befuddled by
the ambiguity between European and American date order, it's
without a doubt the best we can do for a globally understandable
format.

    Brian

---

From: Michael Richardson <[email-masked]>
Date: Sat, 13 Mar 2010 20:54:01 -0500

>>>>> "bill" == bill manning <[email-masked]> writes:
    bill> ISO not withstanding, its still confusing if only because
    bill> other cultures use yyddmm.  If the IETF website used something
    bill> like ISO-2010-01-02 maybe.

Only confusing for americas.

The rest of us are confused by america usage.
I got a bill from a US based company in 2001, due:  09-01-04
I wrote them a checque for 2009 January 4.

-- 
]       He who is tired of Weird Al is tired of life!           |  firewalls  [
]   Michael Richardson, Sandelman Software Works, Ottawa, ON    |net architect[
] [email-masked] http://www.sandelman.ottawa.on.ca/ |device driver[
   Kyoto Plus: watch the video <http://www.youtube.com/watch?v=kzx1ycLXQSE>
	               then sign the petition.

---

From: Jari Arkko <[email-masked]>
Date: Sun, 14 Mar 2010 09:23:22 +0200

John,

> the best solution is a short note on

+1

Jari

---

From: Julian Reschke <[email-masked]>
Date: Sun, 14 Mar 2010 10:29:01 +0100

On 13.03.2010 23:34, Marshall Eubanks wrote:
> most precise, then a useful property is achieved. Assuming that the time
> zones of the dates and times are the same (e.g., all in UTC), expressed
> using the same string (e.g., all "Z" or all "+00:00"), and all times
> have the same number of fractional second digits, then the date and time
> strings may be sorted as strings (e.g., using the strcmp() function in
> C) and a time-ordered sequence will result. The presence of optional
> punctuation would violate this characteristic.
> -----
 > ...

I think the answer is that you need to select a consistent profile of 
ISO-8601 if you want to use string sorting. This is true both for ISO 
8691 and the subset in in RFC 3339, the only difference seems to be that 
there are less options to consider.

Best regards, Julian

---

From: Sabahattin Gucukoglu <[email-masked]>
Date: Sun, 14 Mar 2010 08:38:06 +0000

On 13 Mar 2010, at 14:51, Cullen Jennings wrote:
I just got abused by someone reading the IESG web pages and pointing out dates like 2010-01-02 , are confusing. Is there a better way to do dates that we should be using on the ietf.org web pages?

Incredible discussion so far notwithstanding, I have long since given up trying to coach people using any form of numeric date representations and now just use RFC 5322 format for everything (even when doing so is inconveniently verbose sometimes).  It probably isn't suitable for an international audience for whom the non-use or partial-use of English is a genuine concern, but it by far beats trying to unify the great divide among for instance British and American notations.  I am an email junky anyway.  Otherwise, of course the yyyy-mm-dd makes the most sense, especially in scripts or directory listings.

Cheers,
Sabahattin

---

From: "David A. Bryan" <[email-masked]>
Date: Sat, 13 Mar 2010 10:28:07 -0500

+1. This is the only way that sorts properly, so the only one that makes sense.

David

On Sat, Mar 13, 2010 at 10:06 AM, Marshall Eubanks <[email-masked]> wrote:
> internationally agreed basis. It represents elements from the largest to the
> smallest element: year-month-day:
> where YYYY is the year in the Gregorian calendar, MM is the month of the
> year between 01 (January) and 12 (December), and DD is the day of the month
> between 01 and 31.
>

---

From: Marc Petit-Huguenin <[email-masked]>
Date: Sat, 13 Mar 2010 10:24:36 -0800

> I've replied with roughly "Yep, they might be a bit confusing but everything else is worse so that's what we use".

Another solution is to let the user choose the representation.  Attached is a
patch to add an option in the trac preference panel for the presentation format.

The second attachment is a macro that can be used in the wiki to annotate the
dates, something like this:

[[Date(2010-01-02)]]

For example with a format of "%a, %d %b %Y", the wiki will display this:

Fri, 01 Jan 2010

- -- 
Marc Petit-Huguenin
Personal email: [email-masked]
Professional email: [email-masked]
Blog: http://blog.marc.petit-huguenin.org
--- /usr/share/pyshared/trac/prefs/web_ui.py	2010-03-09 14:49:38.000000000 -0800
+++ /usr/share/pyshared/trac/prefs/web_ui.py.new	2010-03-13 10:11:54.000000000 -0800
@@ -36,7 +36,7 @@
     implements(INavigationContributor, IPreferencePanelProvider,
                IRequestHandler, ITemplateProvider)
 
-    _form_fields = ['newsid', 'name', 'email', 'tz', 'accesskeys']
+    _form_fields = ['newsid', 'name', 'email', 'tz', 'format', 'accesskeys']
 
     # INavigationContributor methods
 
--- /usr/share/pyshared/trac/prefs/templates/prefs_datetime.html	2010-03-09 14:49:38.000000000 -0800
+++ /usr/share/pyshared/trac/prefs/templates/prefs_datetime.html.new	2010-03-13 10:11:38.000000000 -0800
@@ -39,5 +39,13 @@
 
     </div>
 
+    <div class="field">
+		<label>Format:
+			<input type="text" id="format" name="format" size="30" value="${settings.session.get('format')}" />
+		</label>
+      <p class="hint">
+		  ISO8601 or a strftime format string
+      </p>
+    </div>
   </body>
 </html>

---

From: Phillip Hallam-Baker <[email-masked]>
Date: Sat, 13 Mar 2010 17:24:53 -0500

In the UK we use day-month-year. I have never seen  year-day-month.

day-month-year and year-month-day are both logical formats I can use.
the us norm of year-day-month is the only one that I find profoundly
illogical. I would usually require it to be re-written in an
unambiguous form in company docs.

For filenames I would recommend the ISO format as it collates correctly.

Which is of course why our British version of the Internet had a
naming system that worked in the logical order msb->lsb  uk.co.ac.ox

-- 
-- 
New Website: http://hallambaker.com/
View Quantum of Stupid podcasts, Tuesday and Thursday each week,
http://quantumofstupid.com/

---

From: Robert Kisteleki <[email-masked]>
Date: Mon, 15 Mar 2010 16:39:10 +0100

> For example with a format of "%a, %d %b %Y", the wiki will display this:

Uhm, does it work in .txt files? What about PDF-A? :-)

Robert

---

From: Marc Petit-Huguenin <[email-masked]>
Date: Mon, 15 Mar 2010 09:02:24 -0700

> Uhm, does it work in .txt files? What about PDF-A? :-)

No and no

---

From: Martin Rex <[email-masked]>
Date: Mon, 15 Mar 2010 21:31:54 +0100 (MET)

> Just get used to it. And while at it, switch to 24h :-)

IETF Meeting agendas have long been using 24h, but desperately
lacks the GMT offset for the Meeting location.

It would be highly appreciated if the secretariat put in the GMT timezone
offset into the Meeting agenda that applies to the meeting location --
because that is what you need when want to listen to the audio stream
or participate through jabber in real time remotely.

The spring IETF is often very close to the winter time -> daylight savings
time transition, and that date differs between countries.  While it is
simple and consistent within the EU, it appears to vary within the US.

The IETF Meeting Agenda uses the "middle-endian" US date format,
but fortunately spells out month names for disabiguation.

-Martin

---

From: Julian Reschke <[email-masked]>
Date: Mon, 15 Mar 2010 22:17:03 +0100

> lacks the GMT offset for the Meeting location.

Agreed.

In the meantime, the ICS files generated on tools.ietf.org are useful to 
get reliable time information.

Best regards, Julian

---

From: Robert Kisteleki <[email-masked]>
Date: Wed, 17 Mar 2010 16:23:55 +0100

On 2010.03.13. 19:23, Stephane Bortzmeyer wrote:
>   Arnt Gulbrandsen<[email-masked]>  wrote

Fair enough. Inspired by this I actually read the RFC. I find it quite 
amusing that in an RFC that basically says "thou shalt always use 
YYYY-MM-DD", the actual code in appendix B is the following:

char *day_of_week(int day, int month, int year)
{
...
}

Robert

---

From: Phillip Hallam-Baker <[email-masked]>
Date: Wed, 17 Mar 2010 11:38:40 -0400

But the order on the stack is year, month, day!

---

From: Mark Andrews <[email-masked]>
Date: Fri, 19 Mar 2010 08:34:36 +1100

In message <[email-masked]>, Phill
> But the order on the stack is year, month, day!

And the month is *between* the day and the year.  Nothing illogical with
this order.

> >> =A0Arnt Gulbrandsen<[email-masked]> =A0wrote
> >> =A0a message of 17 lines which said:
> >>
> -- =
> -- =